/* ----------------------------------------------- */
/* ----- Sort Request Offering Query Prompts ----- */
/* ----------------------------------------------- */
// v1.0.1
// Tested for: Cireson Portal v5.0.0
$(window).load(function () {
	if (document.URL.indexOf("/SC/ServiceCatalog/RequestOffering/") === -1) { //Only worry about request offering forms
		return; 
	}
	
	//Get all objects that hold our kendo grids.
	var divGridControls = $("div[data-control=checkboxGridByCriteria");
	for (var i = 0; i < divGridControls.length; i++) {
		
		//Re-get this element as an object.
		var thisKendoGrid = $(divGridControls[i]).getKendoGrid();
		var firstColumnName = thisKendoGrid.columns[0].field;
		//var firstColumnTitle = thisKendoGrid.columns[0].title;
		var numberOfRows = thisKendoGrid.dataSource.data().length
		if (numberOfRows > 0) 
		{
			//This grid control already has data. 
			//Sort this grid, using the first column. This will sort only once, after initial page load, whether items exist in the grid or not.
			thisKendoGrid.dataSource.query({
			  sort: { field: firstColumnName, dir: "asc" },
			  page: 1,
			  pageSize: 20,
			});
		}
		else{
			//If this request offering grid uses a previous question filter, then the initial sort won't work. Set up a one-time sort event. 
			thisKendoGrid.one("dataBound", function (e){
				//Note to self. the dataBound fires after the rows are returned, and dataBinding fires before. 
				var thisEventKendoGrid = e.sender;
				console.log(e.sender);
				
				var firstEventColumnName = thisEventKendoGrid.columns[0].field;
				var firstEventColumnTitle = thisEventKendoGrid.columns[0].title;
				//console.log("Databinding changed in event. Sorting by first column '" + firstEventColumnName + "', '" + firstEventColumnTitle + "'");
				thisEventKendoGrid.dataSource.query({
				  sort: { field: firstEventColumnName, dir: "asc" },
				  page: 1,
				  pageSize: 20,
				});
			});
		}
	}
});
/* --- End Sort Request Offering Query Prompts --- */
/* ----------------------------------------------- */